﻿/*  
I still would like to implement more of actual A* with 
a useful heuristic and path weighting. 

Please let me know if you find this useful at all:
     brian.stinar@cs.unm.edu
	 
	 Thanks and enjoy!
*/	 

package com.identityMine.documentClass
{
	
	import flash.display.MovieClip;
	
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	
	
	import flash.display.Stage;
	
	import CELL;
	import STOP_HAND;
	
	// This is a cool looking datastructures library
	import de.polygonal.ds.*;
	
	
	
	public class DocumentClass extends MovieClip
	{

		public var myHand : STOP_HAND;
					
		public var okButton : OK_BUTTON;
		
		public var warningBox : WARNING_BOX;
		
		// Variables related to cell spacing
				
		// how much we want to shift it right
		var shift_right = 50;
		// how much we want to shift it down
		var shift_down = 50;
		// how much space between columns
		var spread_apart = 75;
		// how much space between rows
		var spead_down = 75;
		// how many columns we want
		var columns = 10;
		// how many rows we want
		var rows = 10;
				
		var CellArray : Array = new Array();
		
		private var start_button : START_BUTTON;
		
		private var StartCell : CELL;
		private var EndCell : CELL;
		
		private var debug : Boolean = false;
		
		private function dtrace(input): void{
			if (debug == true){
				trace(input);
			}
		}
		
		public function DocumentClass(){
			
			start_button = new START_BUTTON();
			start_button.y = start_button.y + 850;
			
			// This is the only way I know of to make it so the piece inside of here
			// has a reference to the outside. I think there is probably a way with the 
			// display heirchy, but I'm not certain right now how to do that.
			start_button.setDocumentClass(this);
			//start_buttom.x = start_buttom.x + 100;
			addChild(start_button);
			
			// I start at the top left, and build down.
			// After I build an entire column, then I move to the right and build down again
			for (var i = 0; i < columns; i++){
				for (var j = 0; j < rows; j++){

					var _cell : CELL;
				
					// create the cell
					_cell = new CELL();
					_cell.SetStage(stage);
					_cell.SetIJ(i, j);
					
					// set some of the values I need for each cell
					_cell.setRowsColumns(rows, columns);
					
					// shift it down
					_cell.y = _cell.y + j * spead_down + shift_down;
					
					// shift it apart
					_cell.x = _cell.x + i * spread_apart + shift_right;
				
					_cell.scaleX = 0.05;
					_cell.scaleY = 0.05;
					
					
					// Add the cell to the cell list
					CellArray.push(_cell);
					// Add the cell to the screen
					addChild(_cell);
					
					// if I make our cells aware of the cell array, they receive a complete reference to it, 
					// even if it is not completely filled our right now...
					CellArray[i * columns + j].setNodeList(CellArray);
					
					} // end for j
				} // end for i
							
				// Make our adjacency list
				GenerateAdjacencyList();
				
				// visualizeHelper();
				AdjacencyListChecker();
				
		} // end DocumentClass() constructor
		
		// Method that will actuall do the search on the graph
		public function PerformSearch() : void{
			
			var OpenList : LinkedQueue; // From our handy-dandy MIT liscense library.
			var ClosedList : LinkedQueue;
			
			var possiblePath : Boolean = false;
			
			OpenList = new LinkedQueue();
			ClosedList = new LinkedQueue();
			
			// Check to make sure we have a correct graph before proceeding
			if (checkStartStop() == false){
				return;
			}
			
			// Now, let's do a BFS to see if this sucker works! 
			// So, I put the starting node on the queue,
			// Then I see if it is the ending node, 
			//   if not, then I need to put it's children on the OpenList, if they are not in the closed list
			//   If everything is out of the OpenList, then I quit
			
			OpenList.enqueue(StartCell);
			var currentCell : CELL = new CELL(); 
			
			dtrace("StartCell.iPos = " + StartCell.iPos);
			dtrace("StartCell.jPos = " + StartCell.jPos);
			
			
			dtrace("EndCell.iPos = " + EndCell.iPos);
			dtrace("EndCell.jPos = " + EndCell.jPos);
			
			trace("CellArray.length = " + CellArray.length); 
			
			while(OpenList.isEmpty() == false){
				currentCell = OpenList.dequeue();
				dtrace("currentCell.iPos = " + currentCell.iPos);
				dtrace("currentCell.jPos = " + currentCell.jPos);
				
				if (currentCell == EndCell){
					dtrace("We are done! Found the cell");
					possiblePath = true;
					break;
				}
				
				if (currentCell != EndCell){
					dtrace("currentCell != EndCell");
					ClosedList.enqueue(currentCell); // Add it to the closed list
					dtrace("Adding currentCell to ClosedList");
					// Now, add all the children of the currentCell 
					// to the OpenList, if they don't exist in the ClosedList
					
					dtrace("currentCell.EdgeList.length= " + currentCell.EdgeList.length);
					
					for (var i : int = 0; i < currentCell.EdgeList.length; i++){
						
						// if it is not in the closed list
						
						// Is it EVER in the closed list?
						dtrace("ClosedList.contains(currentCell.EdgeList["+i+"]) =" + ClosedList.contains(currentCell.EdgeList[i]));
						if (ClosedList.contains(currentCell.EdgeList[i]) == false){
							// add it to the open List
							dtrace("Adding Edge[" + i + "] to OpenList");
							OpenList.enqueue(currentCell.EdgeList[i]);
							
							// set the parent for back tracking after we found the result
							currentCell.EdgeList[i].parentCell = currentCell;
							
						} // end not in closed list
					} // end iterate over edges
				} // end check for the cell
			} // end while
			
			if (possiblePath == false){
				trace("Sorry - no path");
				return;
			}
			
			var backTrace; 
			backTrace = EndCell.parentCell;
			
			while(backTrace.parentCell != null){
				backTrace.partOfPath();
				backTrace = backTrace.parentCell;
			}
			
		} // end PerformSearch
		 
		 
		// This method checks to see 
		private function checkStartStop() : Boolean{
			dtrace("inside checkStartStop");
			
		 	myHand = new STOP_HAND();
			//myHand.scaleX = 0.75;
			//myHand.scaleY = 0.75;
			myHand.y = myHand.y + 200;
			myHand.x = myHand.x + 100;
			
			okButton = new OK_BUTTON();
			okButton.setDocumentClass(this);
			okButton.x = okButton.x + 200;
			okButton.y = okButton.y + 600;
			
			warningBox = new WARNING_BOX();
			warningBox.y = warningBox.y + 850;
			warningBox.x = warningBox.x + 575;
			warningBox.scaleX = 0.5;
			warningBox.scaleY = 0.5;
			
			var numStartCells : int = 0;
			var numEndCells : int = 0;
			
			if (CellArray.length != (rows * columns)){
				throw new Error("CellArray.length != rows * columns, something seriously wrong");
				return false;
			}
				
			// Count the number of start cells and end cells we have	
			for (var i : int = 0; i < rows * columns; i++){
				if (CellArray[i].getStartCell() == true){
					numStartCells = numStartCells + 1;
					StartCell = CellArray[i];
					dtrace("CellArray[i].iPos = " + CellArray[i].iPos);
					dtrace("CellArray[i].jPos = " + CellArray[i].jPos);
				}
				
				if (CellArray[i].getEndCell() == true){
					numEndCells = numEndCells + 1;
					dtrace("CellArray[i].iPos = " + CellArray[i].iPos);
					dtrace("CellArray[i].jPos = " + CellArray[i].jPos);
					EndCell = CellArray[i];
				}
			}
			
			// If our number of start cells is not equal to 1
			if (numStartCells > 1){
				// For right now, I want to error our to see if this is working. 
				// During actual execution, I simply want to allow the user to 
				addChild(myHand);
				addChild(okButton);
				addChild(warningBox);
				//throw new Error("You cannot have more than one start cell ");
				return false;
			}
			
			if (numStartCells < 1){
				//throw new Error("You need one start cell");
				addChild(myHand);
				addChild(okButton);
				addChild(warningBox);
				return false;
			}
			
			// If our number of end cells is not equal to 1
			if (numEndCells > 1){
				// Ditto to above
				//throw new Error("You cannot have more than one end cell ");
				addChild(myHand);
				addChild(okButton);
				addChild(warningBox);
				return false;
			}
			
			if (numEndCells < 1){
				// Ditto to above
				addChild(myHand);
				addChild(okButton);
				addChild(warningBox);
				//throw new Error("You need at least one start cell");
				return false;
			}
			
			return true;
		} // end checkStartStop
		
		private function GenerateAdjacencyList(){
		// Iteration to add everything to the adjacency list
			
			for (var i = 0; i < columns; i++){
				for (var j = 0; j < rows; j++){
					//var _cell : CELL = CellArray[i * columns + j];
					
					if (i < columns - 1){
						CellArray[i * columns + j].AddArrow(CellArray[(i + 1 )* columns + j]);
					}
					
					if (i > 0){
						CellArray[i * columns + j].AddArrow(CellArray[(i - 1) * columns + j]);
					}
										
					if (j > 0){
						CellArray[i * columns + j].AddArrow(CellArray[(i * columns) + j - 1]);
					}
					
					if (j < rows - 1){
						CellArray[i * columns + j].AddArrow(CellArray[(i * columns + j + 1)]);
					}
					
					//for (var k : int = 0; i < CellArra
										
				} // end for j
				
			}// end for i
				
			
		} // end GenerateAdjacencyList()

		
		
		private function visualizeHelper(){
			/*
			// A helpful routine for visualizing how the array is layed out
			*/
			
			// Our cell
			CellArray[1 * 10 + 2].test();
			// CellArray[i * 10 + j]
			
			// One above our cell				
			CellArray[1 * 10 + 1].test2(); 
			// CellArray[i * columns + j - 1 ]
				
			// One to the left of our cell
			CellArray[0 * 10 + 2].test2();
			// CellArray[(i - 1) * columns + j]
				
			// One to the right of our cell
			CellArray[2 * 10 + 2].test2();
			// CellArray[(i + 1) * columns + j]
				
			// One below our cell
			CellArray[1 * 10 + 3].test2();
			// CellArray[i * columns + j + 1]

		} // end visualizeHelper()
		
		private function AdjacencyListChecker(){
			// This method goes through and calculates the number of nodes that have 2, 3, and 4 elements in their adjacency list
			// This is to make sure I am calculating everything correctly.
			
			var twos : int = 0;
			var threes : int = 0;
			var fours : int = 0;
			
			for (var i = 0; i < columns; i++){
					for (var j = 0; j < rows; j++){
						
						// We should only have 4 elements with 2 items in their adjacency list, these are the four corners
						if (CellArray[i * columns + j].EdgeList.length == 2){
							twos = twos + 1;
						}
						
						// For threes, we have 2 * (rows - 2) + 2 * (columns - 2)
						// since we have the top and bottom row, minus their two corners PLUS
						//     two for the right and left column, minus their two corners
						if (CellArray[i * columns + j].EdgeList.length == 3){
							threes = threes + 1;
						}
						
						if (CellArray[i * columns + j].EdgeList.length == 4){
							fours = fours + 1;
						}
						
					} // end for j
			} // end for i
		
			trace("two's = " + twos);
			trace("three's = " + threes);
			var sum : int = (2 * (rows - 2)) + (2 * (columns - 2));
			trace("   (2 * (rows - 2)) + (2 * (columns - 2)) = " + sum + "(what threes should be)");
			trace("fours = " + fours);
			sum = (rows - 2) * (columns - 2);
			trace ("(rows - 2) * (columns - 2) = " + sum + "(what fours should be)");
		
		} // end AdjacencyListChecker()
		
	} // end class DocumentClass
	
} // end package